交换瓶子【第七届】【省赛】【A组】

题目描述

有N个瓶子,编号 1 ~ N,放在架子上。

比如有5个瓶子:

2 1 3 5 4

要求每次拿起2个瓶子,交换它们的位置。

经过若干次后,使得瓶子的序号为:

1 2 3 4 5

对于这么简单的情况,显然,至少需要交换2次就可以复位。

如果瓶子更多呢?你可以通过编程来解决。

输入输出

输入格式为两行:

第一行: 一个正整数N(N<10000), 表示瓶子的数目

第二行:N个正整数,用空格分开,表示瓶子目前的排列情况。

输出数据为一行一个正整数,表示至少交换多少次,才能完成排序。

例如,输入:

5

3 1 2 5 4

程序应该输出:

3

再例如,输入:

5

5 4 3 2 1

程序应该输出:

2

资源约定

峰值内存消耗 < 256M

CPU消耗 < 3000ms

思路

这题思路很巧妙,我们可以将其转化为图论的问题求解。

首先建图,因为是1~N的,所以将ai指向aa\[i],例如第一个样例。

复制代码
5
3 1 2 5 4

转化成图就行如下所示。

排好之后的图是这样的。

所以我们的目的就是将上面的两个环,变成下面的五个环。每次交换两个点,其实就是改变了两条边的指向。比如交换3和2,就变成了2 1 3 5 4。新图就变成了:

其实就是将一个环变成了两个环。每一次这样的交换都会导致上述结果。那么我们最终是要有 n n n 个环。所以我们只需要求出给出的数据有多少环,然后让 n n n 减去环的数量,就是最少的交换次数。

代码

c 复制代码
#include <iostream>
#include <algorithm>

using namespace std;

const int N = 10010;

int n;
int a[N];
bool st[N];

int main()
{
    cin >> n;
    for ( int i = 1; i <= n; i ++ ) cin >> a[i];
    
    int k = 0;
    
    for ( int i = 1; i <= n; i ++ )
        if ( !st[i] )
        {
            k ++;
            for ( int j = i; !st[j]; j = a[j] )
                st[j] = true;
        }
    cout << n - k << endl;
    
    return 0;
}
相关推荐
朔北之忘 Clancy14 小时前
2025 CSP-J 第二轮真题解析
c++·青少年编程·题解·noip·csp·信奥赛·noi
longlongzihan14 小时前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
yolo_guo14 小时前
调试mysql延迟与libevent回调实际发送回复时机问题
c++·mysql·libevent
封印师请假去地球钓鱼14 小时前
边解边变的问题:从“决策依赖“一词出发
人工智能·算法
今晚打老虎15 小时前
c++之提高A(前缀和)(第三课)
数据结构·c++·算法
不会就选b16 小时前
算法日常・每日刷题--<贪心>26
数据结构·算法
by2099916 小时前
从结构体到对象:正式学习C++类的骨架、封装与this指针
c++·经验分享·学习
2601_9622186117 小时前
C语言中三种库的编译和使用方法
开发语言·c++
jimy117 小时前
派生类重写基类虚函数(二):override的作用
开发语言·c++
ebiobiz17 小时前
基于 GD32 Embedded Builder (GEB) 与 Nimmake 的 MCU 工程搭建指南
c++·python·单片机·嵌入式硬件·mcu